/* $Id: isdnlog.c,v 2.2.5 1996/03/28 21:28:46 root Exp $
 *
 * ISDN accounting for isdn4linux. (log-module)
 *
 * Copyright 1995, 1996 by Andreas Kool (akool@Kool.f.EUnet.de)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: isdnlog.c,v $
 * Revision 2.2.5  1996/03/28  21:28:46  akool
 * Fix in Exit() (sl)
 * 1TR6-Unterstuetzung fertiggestellt
 * Neuer Switch "-e" zum Unterdruecken der "tei" Angabe
 *
 * Revision 2.2.4  1996/03/24  12:17:46  akool
 * 1TR6 Causes implemented
 * 1TR6 / E-DSS1 Frames werden unterschieden
 * Pipe-Funktionalitaet reaktiviert 19-03-96 Bodo Bellut (lasagne@garfield.ping.de)
 * Alle Console-Ausgaben wieder mit \r
 * Gebuehrenauswertung fuer 1TR6 implementiert (Wim Bonis (bonis@kiss.de))
 *
 * Revision 2.23  1996/03/17  12:26:46  akool
 *
 * Revision 2.20  1996/03/11  21:15:46  akool
 * Calling/Called party decoding
 *
 * Revision 2.19  1996/03/10  19:46:46  akool
 * Alarm-Handling fuer /dev/isdnctrl0 funzt!
 *
 * Revision 2.17  1996/02/25  19:23:46  akool
 * Andy's Geburtstags-Release
 *
 * Revision 2.15  1996/02/21  20:38:46  akool
 * sl's Server-Verschmelzung
 * Gernot's Parken/Makeln
 *
 * Revision 2.15  1996/02/17  21:01:10  root
 * Nun geht auch Parken und Makeln
 *
 * Revision 2.14  1996/02/17  16:00:00  root
 * Zeitfehler weg
 *
 * Revision 2.15  1996/02/21  20:30:42  akool
 * sl's Serververschmelzung
 * Gernot's Makeln
 *
 * Revision 2.13  1996/02/15  21:03:42  akool
 * ein kleiner noch
 * Gernot's Erweiterungen implementiert
 * MSG_CALL_INFO enthaelt nun State
 *
 * Revision 2.12  1996/02/13  20:08:43  root
 * Nu geht's (oder?)
 *
 * Revision 1.4  1996/02/13  20:05:28  root
 * so nun gehts
 *
 * Revision 1.3  1996/02/13  18:08:45  root
 * Noch ein [ und ein ;
 *
 * Revision 1.2  1996/02/13  18:02:40  root
 * Haben wir's drin - erster Versuch!
 *
 * Revision 1.1  1996/02/13  14:28:14  root
 * Initial revision
 *
 * Revision 2.10  1996/02/12  20:38:16  akool
 * TEI-Handling von Gernot Zander
 *
 * Revision 2.06  1996/02/10  20:10:16  akool
 * Handling evtl. vorlaufender "0" bereinigt
 *
 * Revision 2.05  1996/02/05  21:42:16  akool
 * Signal-Handling eingebaut
 * AVON-Handling implementiert
 *
 * Revision 2.04  1996/01/31  18:30:16  akool
 * Bugfix im C/S
 * Neue Option "-R"
 *
 * Revision 2.03  1996/01/29  15:13:16  akool
 * Bugfix im C/S

 * Revision 2.02  1996/01/27  15:13:16  akool
 * Stefan Luethje's Client-/Server Anbindung implementiert
 * Bugfix bzgl. HANGUP ohne AOCE-Meldung
 *
 * Revision 2.01  1996/01/21  15:32:16  akool
 * Erweiterungen fuer Michael 'Ghandi' Herold implementiert
 * Syslog-Meldungen implementiert
 * Reread der isdnlog.conf bei SIGHUP implementiert
 * AOCD/AOCE Auswertungen fuer Oesterreich implementiert
 *
 * Revision 2.00  1996/01/10  20:10:16  akool
 * Vollstaendiges Redesign, basierend auf der "call reference"
 * WARNING: Requires Patch of 'q931.c'
 *
 * Revision 1.25  1995/11/18  14:38:16  akool
 * AOC von Anrufen auf 0130-xxx werden korrekt ausgewertet
 *
 * Revision 1.24  1995/11/12  11:08:16  akool
 * Auch die "call reference" wird (ansatzweise) ausgewertet
 * Neue Option "-x" aktiviert X11-Popup
 * Date/Time wird ausgewertet
 * AOC-D wird korrekt ausgewertet
 * Neue Option "-t" setzt Systemzeit auf die von der VSt gemeldete
 * Die "-m" Option kann nun auch mehrfach (additiv) angegeben werden
 *
 * Revision 1.23  1995/11/06  18:03:16  akool
 * "-m16" zeigt die Cause im Klartext an
 * Auch Gebuehreneinheiten > 255 werden korrekt ausgewertet
 *
 * Revision 1.22  1995/10/22  14:43:16  akool
 * General cleanup
 * "isdn.log" um 'I' == dialin / 'O' == dialout erweitert
 * Auch nicht zustande gekommene Verbindungen werden (mit cause)
 * protokolliert
 *
 * Revision 1.21  1995/10/18  21:25:16  akool
 * Option "-r" implementiert
 * Charging-Infos waehrend der Verbindung (FACILITY) werden ignoriert
 * "/etc/isdnlog.pid" wird erzeugt
 *
 * Revision 1.20  1995/10/15  17:23:16  akool
 * Volles D-Kanal Protokoll implementiert (fuer Teles-0.4d Treiber)
 *
 * Revision 1.13  1995/09/30  09:34:16  akool
 * Option "-m", Console-Meldung implementiert
 * Flush bei SIGTERM implementiert
 *
 * Revision 1.12  1995/09/29  17:21:13  akool
 * "isdn.log" um Zeiteintrag in UTC erweitert
 *
 * Revision 1.11  1995/09/28  18:51:17  akool
 * First public release
 *
 * Revision 1.1  1995/09/16  16:54:12  akool
 * Initial revision
 *
 */

 /* Letzte Exit-Nummer: 21 */


#define _ISDNLOG_C_
#include "isdnlog.h"


static char    usage[]   = "%s: usage: %s [ -%s ] file\n";
static char    options[] = "avsi:x:m:l:rt:cC:w:SVTRDPe";

static char    msg1[]    = "%s: Can't open %s (%s)\n";

static FILE   *flog      = (FILE *)NULL;   /* /var/adm/isdn.log          */
static FILE   *fcons 	 = (FILE *)NULL;   /* /dev/ttyX      (or stderr) */
static FILE   *fprot 	 = (FILE *)NULL;   /* /tmp/isdnctrl0 	 	 */

static CALL    call[MAXCHAN];
static int     chan;
static int     message = PRT_NOTHING, syslogmessage = PRT_NOTHING;
static int     pid = -1;
static int     xinfo = 0, sound = 0, trace = 0, daemon = 0;
static int     port = 0;
static int     wakeup = 5;
static clock_t tt;
static char    st[64], stl[64];
static char    infocmd[BUFSIZ];
static int     settime = 0, connectinfo = 0, replay = 0, replaydev = 0;
static int     verbose = 0, synclog = 0, any = 1, stdoutput = 0, showtei = 1;
static int     allflags = 0;


static void set_time_str()
{
  auto struct tm *tm_time = localtime(&cur_time);


  tm_time->tm_isdst = 0;

  strftime(stl, 64, "%a %b %d %X %Y", tm_time);
  strftime(st, 64, "%a %b %d %X", tm_time);
} /* set_time_str */


static void logger(int chan)
{
  register char  *p;
  auto 	   char   s[BUFSIZ];


  strcpy(s, ctime(&call[chan].connect));

  if ((p = strchr(s, '\n')))
    *p = 0;

  fprintf(flog, "%s|%-16s|%-16s|%5d|%10d|%10d|%5d|%c|%3d|%10ld|%10ld|\n",
    s + 4, call[chan].num[CALLING], call[chan].num[CALLED],
    (int)(call[chan].disconnect - call[chan].connect),
    (int)call[chan].duration, (int)call[chan].connect,
    call[chan].aoce, call[chan].dialin ? 'I' : 'O',
    call[chan].cause, call[chan].ibytes, call[chan].obytes);

  fflush(flog);

} /* logger */


static void diag(int cref, int tei, int dialin, int net, int type, int version)
{
  char String[LONG_STRING_SIZE];
  char TmpString[LONG_STRING_SIZE];


  if (dialin != -1) {
    sprintf(String,"  DIAG> %s: %3d/%3d %3d %s %s %s-> ",
      st + 4, cref, cref & 0x7f, tei,
      ((version == VERSION_1TR6) ? "1TR6" : "E-DSS1"),
      dialin ? " IN" : "OUT",
      net ? "NET" : "USR");

    if ((cref > 128) && (type == SETUP_ACKNOWLEDGE)) {
      sprintf(TmpString," *%d* ", cref);
      strcat(String, TmpString);
    } /* if */

  } /* if */

  switch (type) {
    case ALERTING            : sprintf(TmpString, " ALERTING\n");
    	 		       break;

    case CALL_PROCEEDING     : sprintf(TmpString, " CALL PROCEEDING\n");
    	 		       break;

    case SETUP               : sprintf(TmpString, " SETUP\n");
    	 		       break;

    case SETUP_ACKNOWLEDGE   : sprintf(TmpString, " SETUP ACKNOWLEDGE\n");
    	 		       break;

    case CONNECT             : sprintf(TmpString, " CONNECT\n");
    	 		       break;

    case CONNECT_ACKNOWLEDGE : sprintf(TmpString, " CONNECT ACKNOWLEDGE\n");
    	 		       break;

    case FACILITY 	     : sprintf(TmpString, " FACILITY\n");
    	 		       break;

    case NOTIFY 	     : sprintf(TmpString, " NOTIFY\n");
    	 		       break;

    case STATUS 	     : sprintf(TmpString, " STATUS\n");
    	 		       break;

    case DISCONNECT 	     : sprintf(TmpString, " DISCONNECT\n");
    	 		       break;

    case RELEASE 	     : sprintf(TmpString, " RELEASE\n");
    	 		       break;

    case RELEASE_COMPLETE    : sprintf(TmpString, " RELEASE COMPLETE\n");
    	 		       break;

    default 		     : sprintf(TmpString, " TYPE 0x%0x\n", type);
    			       break;
  } /* switch */

  strcat(String, TmpString);
  print_msg(PRT_DEBUG_GENERAL, "%s", String);
} /* diag */


static void info(int chan, int reason, int state, char *msg)
{
  auto char   s[BUFSIZ], *indent;


  if (allflags & PRT_DEBUG_GENERAL)
    if (allflags & PRT_DEBUG_INFO)
      print_msg(PRT_DEBUG_INFO, "  INFO> ");
    else
      return;

  if (!*msg) {
    if (call[chan].self)
      msg = "(Selbstanruf!)";
    else
      switch (call[chan].bearer) {
        case 0 : msg = "Digital"; break;
        case 1 : msg = "Analog";  break;
        case 7 : msg = "Digital"; break; /* evtl. _nur_ fuer 1TR6 gueltig? */
      } /* switch */
  } /* if */

  switch (chan) {
     case 0 : indent = "";   break;
     case 1 : indent = "  "; break;
    default : indent = "* "; break;
  } /* switch */

  if (call[chan].dialin) {

    if (call[chan].tei && showtei)
      sprintf(s, "%s %sCall to tei %d from %s on %s  %s\n",
         st + 4, indent,
         call[chan].tei,
         call[chan].vnum[CALLING],
         call[chan].vnum[CALLED],
         msg);
    else
      sprintf(s, "%s %sCall from %s on %s  %s\n",
        st + 4, indent,
        call[chan].vnum[CALLING],
        call[chan].vnum[CALLED],
        msg);

  }
  else {
    if (showtei)
      sprintf(s, "%s %stei %d calling %s with %s  %s\n",
     	  st + 4, indent,
      	  call[chan].tei,
      	  call[chan].vnum[CALLED],
      	  call[chan].vnum[CALLING],
      	  msg);
    else
      sprintf(s, "%s %sCalling %s with %s  %s\n",
    	  st + 4, indent,
      	  call[chan].vnum[CALLED],
      	  call[chan].vnum[CALLING],
      	  msg);
  } /* else */

  print_msg(PRT_DEBUG_INFO, "%s", s);

  print_msg(reason, "%s", s);

  if (xinfo) {
    strcpy(call[chan].msg, msg);
    call[chan].stat = state;
    message_from_server(&(call[chan]), chan);

    print_msg(PRT_DEBUG_CS, "SOCKET> %s: MSG_CALL_INFO chan=%d\n", st + 4, chan);
  } /* if */
} /* info */


static void waitchild(int isig)
{
  signal(SIGCHLD, SIG_DFL);

  if (pid != -1) {
    (void)kill(pid, SIGTERM);
    (void)waitpid(pid, NULL, 0);

    pid = -1;
  } /* if */
} /* waitchild */


static void tell(char *infocmd, char *arg)
{
  register char *p;
  auto 	   int   fd;


  if (allflags & PRT_DEBUG_GENERAL)
    print_msg(PRT_DEBUG_EXEC, "  EXEC> exec(%s,%s)\n", infocmd, arg);
  else {
    if (pid != -1)
      waitchild(SIGCHLD);

    pid = fork();

    if (!pid) { /* child */
      fd = open("/dev/null", O_RDWR);
      close(0);
      dup2(fd, 0);
      close(fd);
      fd = open("/dev/console", O_RDWR);
      close(1);
      close(2);
      dup2(fd, 1);
      dup2(fd, 2);
      close(fd);

      setpgrp();

      if ((p = strchr(infocmd, '$'))) {
        *p = 0;
        (void)execl(infocmd, infocmd, arg, p + 2, NULL);
      }
      else
        (void)execl(infocmd, infocmd, arg, NULL);

      Exit(1);
    }
    else if (pid > 0) /* parent */
      signal(SIGCHLD, waitchild);
  } /* else */
} /* tell */


static void teller(int chan)
{
  register int i, hit = 0;


  if (*infocmd) {

    if (!*call[chan].num[CALLING] && !*call[chan].num[CALLED]) {
      if (knowns && *known[0]->infoarg)
        tell(infocmd, known[0]->infoarg);
    }
    else {
      hit = 0;

      if (abs(mymsns) > 9)
        mymsns = min(knowns, 9);

      for (i = mymsns; i < knowns; i++)
        if (*known[i]->infoarg &&
            match(call[chan].num[call[chan].dialin ? CALLING : CALLED],
                  known[i]->num)) {
          tell(infocmd, known[i]->infoarg);
          hit++;
          break;
        } /* if */

      if (!hit)
        for (i = 0; i < mymsns; i++)
          if (*known[i]->infoarg &&
            match(call[chan].num[call[chan].dialin ? CALLED : CALLING],
                  known[i]->num)) {
            tell(infocmd, known[i]->infoarg);
            break;
          } /* if */
    } /* else */
  } /* if */
} /* teller */


static void ringer(int chan, int event)
{
  register int i, c;


  /* chan; Der jeweilige B-Kanal (0 oder 1)

     event:
       RING_RING    = Nummern wurden uebertragen
       RING_CONNECT = Hoerer abgenommen
       RING_KILL    = Hoerer aufgelegt
       RING_AOCD    = Gebuehrenimpuls (wird noch nicht verwendet)
  */

  for (i = CALLING; i <= CALLED; i++) {   /* fuer beide beteilige Telefonnummern */
    c = call[chan].confentry[i];

    if (c != -1) { /* wenn Eintrag in isdnlog.conf gefunden */
      int f = known[c]->flags; /* die Flags zu diesem Eintrag */

      /* Wenn Event (siehe oben) passt, und INCOMING/OUTGOING passen */

      if ((f & event) && ((call[chan].dialin && (f & RING_INCOMING)) ||
                         (!call[chan].dialin && (f & RING_OUTGOING)))) {

        if (call[chan].sock > 0)           /* wenn auf Kanal 'chan' gerade ein Sound laeuft ... */
          Ring(NULL, call[chan].sock, 0);  /* den umbringen */

        if (CheckTime(known[c]->time))     /* wenn die angegebene Zeit passt */
          call[chan].sock =
            Ring(known[c]->infoarg, (pid_t)0, !(f & RING_KILL));
      } /* if */
    } /* if */
  } /* for */
} /* ringer */


static void hup_handler(int isig)
{
  print_msg(PRT_INFO, "re-reading %s\n", CONFFILE);

  discardconfig();
  readconfig(myname);

  signal(SIGHUP, hup_handler);
} /* hup_handler */


#ifdef OLD_AOC
static int AOC(int l, char *p)
{
  register int   i, c, x = 0;
  auto	   int	 ID = 0, OP = 0, EH = 0;
#if V2
  register char *pc;
  auto 	   char  CUR[16];
#endif


  c = strtol(p += 3, NIL, 16);              /* Ext/Spare/Profile */

  c = strtol(p += 3, NIL, 16);        	    /* Invoke Comp Type */
  c = strtol(p += 3, NIL, 16);        	    /* Invoke Comp Length */
  c = strtol(p += 3, NIL, 16);        	    /* Invoke ID Type */

  l = strtol(p += 3, NIL, 16);        	    /* Invoke ID Length */

  while (l--) {
    ID = ID << 8;
    ID += strtol(p += 3, NIL, 16);    	    /* Invoke ID Contents */
  } /* while */

  c = strtol(p += 3, NIL, 16); 	      	    /* Operation Type */

  l = strtol(p += 3, NIL, 16); 	      	    /* Operation Length */

  while (l--) {
    OP = OP << 8;
    OP += strtol(p += 3, NIL, 16);    	    /* Operation Content */
  } /* while */

  c = strtol(p += 3, NIL, 16); 	      	    /* Sequence Type */

  l = strtol(p += 3, NIL, 16);        	    /* Sequence Length */

  if (!l)      	     	  	      	    /* VSt Giessen meldet so: */
    return(AOC_130);                        /* "Free of charge" */

  if (OP == 0x22) {

#if V2
    c = strtol(p += 3, NIL, 16);      	    /* Recorded Currency Type */
    l = strtol(p += 3, NIL, 16);      	    /* Recorded Currency Length */

    c = strtol(p += 3, NIL, 16);      	    /* Currency Type */
    l = strtol(p += 3, NIL, 16);            /* Currency Length */

    pc = CUR;

    while (l--) {
      *pc++ = (char)strtol(p += 3, NIL, 16) /* Currency Contents */
    } /* while */

    c = strtol(p += 3, NIL, 16);       	    /* Amount Type */
    l = strtol(p += 3, NIL, 16);      	    /* Amount Length */

    while (l--) {
      EH = EH << 8;
      EH += strtol(p += 3, NIL, 16);        /* Amount */
    } /* while */

#else

    for (i = 0; i < 5; i++)            	    /* 5 Byte unknown */
      c = strtol(p += 3, NIL, 16); 	    /* unknown */

    l = strtol(p += 3, NIL, 16);      	    /* length */

    while (l--) {
      EH = EH << 8;
      EH += strtol(p += 3, NIL, 16);
    } /* while */

    c = strtol(p += 3, NIL, 16); 	    /* unknown */

    l = strtol(p += 3, NIL, 16);      	    /* length */

    while (l--) {
      x = x << 8;
      x += strtol(p += 3, NIL, 16);
    } /* while */

    if (x)       /* AOC-E */
      EH = EH;
    else         /* AOC-D */
      EH = -EH;
#endif

  }
  else if (OP == 0x24) {
    for (i = 0; i < 7; i++) {          	    /* 7 Byte unknown */
      c = strtol(p += 3, NIL, 16); 	    /* unknown */

      if ((i == 1) && !c)     		    /* so melden andere VSt */
        return(AOC_130);		    /* "Free of charge" */
    } /* for */

    l = strtol(p += 3, NIL, 16);      	    /* length */

    while (l--) {
      EH = EH << 8;
      EH += strtol(p += 3, NIL, 16);
    } /* while */

  }
  else if (OP == 0x21) {   		    /* AOCD Oesterreich */
    for (i = 0; i < 2; i++)                 /* 2 Byte unknown */
      c = strtol(p += 3, NIL, 16);          /* unknown */

    c = strtol(p += 3, NIL, 16);            /* Currency Type */
    l = strtol(p += 3, NIL, 16);            /* Currency Length */

    while (l--)
      c = strtol(p += 3, NIL, 16);          /* Currency Contents */

    for (i = 0; i < 3; i++)                 /* 3 Byte unknown */
      c = strtol(p += 3, NIL, 16);          /* unknown */

    l = strtol(p += 3, NIL, 16);            /* Amount Length */

    while (l--) {
      EH = EH << 8;
      EH += strtol(p += 3, NIL, 16);        /* Amount */
    } /* while */

    EH = -EH; /* AOC-D */

  }
  else if (OP == 0x23) {                    /* AOCE Oesterreich */
    for (i = 0; i < 4; i++)                 /* 4 Byte unknown */
      c = strtol(p += 3, NIL, 16);          /* unknown */

    c = strtol(p += 3, NIL, 16);            /* Currency Type */
    l = strtol(p += 3, NIL, 16);            /* Currency Length */

    while (l--)
      c = strtol(p += 3, NIL, 16);          /* Currency Contents */

    for (i = 0; i < 3; i++)                 /* 3 Byte unknown */
      c = strtol(p += 3, NIL, 16);          /* unknown */

    l = strtol(p += 3, NIL, 16);            /* Amount Length */

    while (l--) {
      EH = EH << 8;
      EH += strtol(p += 3, NIL, 16);        /* Amount */
    } /* while */

  } /* else */

  return(EH);
} /* AOC */

#else

static void aoc_debug(char *s)
{
  print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: %s\n", st + 4, s);
} /* aoc_debug */


static int AOC(int l, char *p, int type)
{
  int   c, ret = 0;
  static int ID = 0, OP = 0, EH = 0, MP = 0;

  switch(type) {
    case AOC_INITIAL:
      aoc_debug("AOC_INITIAL");
      ID = OP = EH = MP = 0;
      c = strtol(p += 3, NIL, 16);              /* Ext/Spare/Profile */
      ret += 3;

      c = strtol(p += 3, NIL, 16);              /* Invoke Comp type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);              /* Invoke Comp length */
      ret += 3;

      c = strtol(p += 3, NIL, 16);              /* Invoke ID type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);              /* Invoke ID length */
      ret += 3;

      while (l--) {
        ID = ID << 8;
        ID += strtol(p += 3, NIL, 16);          /* Invoke ID Contents */
        ret += 3;
      } /* while */

      c = strtol(p += 3, NIL, 16);              /* OPERATION type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);              /* OPERATION length */
      ret += 3;

      while (l--) {
        OP = OP << 8;
        OP += strtol(p += 3, NIL, 16);          /* OPERATION contents */
        ret += 3;
      } /* while */

      switch (OP) {
        case 0x21:
          c = AOC(l, p, AOCDCurrency);
          p += c;
          EH = -EH; /* AOC-D */
          ret = EH;
          break;

        case 0x22:
          c = AOC(l, p, AOCDChargingUnit);
          p += c;
          ret = -EH;
          break;

        case 0x23:
          c = AOC(l, p, AOCECurrency);
          p += c;
          ret = EH;
          break;

        case 0x24:
          c = AOC(l, p, AOCEChargingUnit);
          p += c;
          ret = -EH;
          break;

      }
      break;

    case AOCDCurrency:
      aoc_debug("AOCDCurrency");
      c = AOC(l, p, AOCDCurrencyInfo);
      p += c;
      ret += c;
      break;

    case AOCDChargingUnit:
      aoc_debug("AOCDChargingUnit");
      c = AOC(l, p, AOCDChargingUnitInfo);
      p += c;
      ret += c;
      break;

    case AOCECurrency:
      aoc_debug("AOCECurrency");
      c = AOC(l, p, AOCECurrencyInfo);
      p += c;
      ret += c;
      break;

    case AOCEChargingUnit:
      aoc_debug("AOCEChargingUnit");
      c = AOC(l, p, AOCEChargingUnitInfo);
      p += c;
      ret += c;
      break;

    case AOCDChargingUnitInfo:
      aoc_debug("AOCDChargingUnitInfo");
      c = strtol(p += 3, NIL, 16);  /* specificChargingUnits SEQUENCE type / NULL */
      ret += 3;
      l = strtol(p += 3, NIL, 16);  /* specificChargingUnits SEQUENCE length / NULL */
      ret += 3;

      if (!l)                                 /* freeOfCharge */
        return(AOC_130);

      c = AOC(l, p, RecordedUnitsList);
      p += c;
      ret += c;
      c = AOC(l, p, TypeOfChargingInfo);
      p += c;
      ret += c;
      /* c = AOC(l, p, AOCDBillingId);
         p += c;
         ret += c; */
      break;

    case AOCEChargingUnitInfo:
      aoc_debug("AOCEChargingUnitInfo");
      c = strtol(p += 3, NIL, 16);            /* SEQUENCE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE length */
      ret += 3;

      c = strtol(p += 3, NIL, 16);  /* specificChargingUnits SEQUENCE type / NULL */
      ret += 3;
      l = strtol(p += 3, NIL, 16);  /* specificChargingUnits SEQUENCE length / NULL */
      ret += 3;

      if (!l)                                 /* freeOfCharge */
        return(AOC_130);

      c = AOC(l, p, RecordedUnitsList);
      p += c;
      ret += c;
      c = AOC(l, p, TypeOfChargingInfo);
      p += c;
      ret += c;
      /* c = AOC(l, p, AOCDBillingId);
         p += c;
         ret += c; */
      break;

    case AOCDCurrencyInfo:
      aoc_debug("AOCDCurrencyInfo");
      c = strtol(p += 3, NIL, 16);  /* specificCurrency SEQUENCE type / NULL */
      ret += 3;
      l = strtol(p += 3, NIL, 16);  /* specificCurrency SEQUENCE length / NULL */
      ret += 3;

      if (!l)                                 /* freeOfCharge */
        return(AOC_130);

      c = strtol(p += 3, NIL, 16);            /* SEQUENCE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE length */
      ret += 3;

      c = AOC(l, p, RecordedCurrency);
      p += c;
      ret += c;
      c = AOC(l, p, TypeOfChargingInfo);
      p += c;
      ret += c;
      /* c = AOC(l, p, AOCDBillingId);
         p += c;
         ret += c; */
      break;

    case AOCECurrencyInfo:
      aoc_debug("AOCECurrencyInfo");
      c = strtol(p += 3, NIL, 16);            /* SEQUENCE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE length */
      ret += 3;

      c = strtol(p += 3, NIL, 16);  /* specificCurrency SEQUENCE type / NULL */
      ret += 3;
      l = strtol(p += 3, NIL, 16);  /* specificCurrency SEQUENCE length / NULL */
      ret += 3;

      if (!l)                                 /* freeOfCharge */
        return(AOC_130);

      c = strtol(p += 3, NIL, 16);            /* SEQUENCE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE length */
      ret += 3;

      c = AOC(l, p, RecordedCurrency);
      p += c;
      ret += c;
      /* c = AOC(l, p, AOCDBillingId);
         p += c;
         ret += c; */
      /* c = AOC(l, p, ChargingAssociation);
         p += c;
         ret += c; */
      break;

    case RecordedCurrency:
      aoc_debug("RecordedCurrency");
      c = strtol(p += 3, NIL, 16);            /* IA5String type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* IA5String length */
      ret += 3;

      c = AOC(l, p, Currency);
      p += c;
      ret += c;

      c = strtol(p += 3, NIL, 16);            /* SEQUENCE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE length */
      ret += 3;

      c = AOC(l, p, Amount);
      p += c;
      ret += c;
      break;

    case Currency:
      aoc_debug("Currency");
      currency = (char *) malloc(l + 1);
      c = 0;
      while (l--) {
        currency[c++] = strtol(p += 3, NIL, 16);
        ret += 3;
      } /* while */
      break;

    case Amount:
      aoc_debug("Amount");
      c = strtol(p += 3, NIL, 16);            /* INTEGER type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* INTEGER length */
      ret += 3;

      c = AOC(l, p, CurrencyAmount);
      p += c;
      ret += c;

      c = strtol(p += 3, NIL, 16);            /* ENUMERATED type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* ENUMERATED length */
      ret += 3;

      c = AOC(l, p, Multiplier);
      p += c;
      ret += c;
      break;

    case CurrencyAmount:
      aoc_debug("CurrencyAmount");
      while (l--) {
        EH = EH << 8;
        EH += strtol(p += 3, NIL, 16);        /* Amount */
        ret += 3;
      } /* while */
      break;

    case Multiplier:
      aoc_debug("Multiplier");
      while (l--) {
        MP = MP << 8;
        MP += strtol(p += 3, NIL, 16);        /* Multiplier */
        ret += 3;
      } /* while */
      switch (MP) {
        case 0:
          currency_factor = 0.001;
          break;
        case 1:
          currency_factor = 0.01;
          break;
        case 2:
          currency_factor = 0.1;
          break;
        case 3:
          currency_factor = 1.0;
          break;
        case 4:
          currency_factor = 10.0;
          break;
        case 5:
          currency_factor = 100.0;
          break;
        case 6:
          currency_factor = 1000.0;
          break;
      }
      break;

    case RecordedUnitsList:
      aoc_debug("RecordedUnitsList");
      c = strtol(p += 3, NIL, 16);            /* SEQUENCE SIZE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE SIZE length */
      ret += 3;

      c = AOC(l, p, RecordedUnits);
      p += c;
      ret += c;
      break;

    case RecordedUnits:
      aoc_debug("RecordedUnits");
      c = strtol(p += 3, NIL, 16);            /* SEQUENCE type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* SEQUENCE length */
      ret += 3;

      if (!l)                                 /* notAvailable */
        return(AOC_130);

      c = AOC(l, p, NumberOfUnits);
      p += c;
      ret += c;

      break;

   case NumberOfUnits:
      aoc_debug("NumberOfUnits");
      c = strtol(p += 3, NIL, 16);            /* INTEGER type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* INTEGER length */
      ret += 3;

      while (l--) {
        EH = EH << 8;
        EH += strtol(p += 3, NIL, 16);        /* NumberOfUnits */
        ret += 3;
      } /* while */

      break;

    case TypeOfChargingInfo:
      aoc_debug("TypeOfChargingInfo");
      c = strtol(p += 3, NIL, 16);            /* typeOfChargingInfo type */
      ret += 3;
      l = strtol(p += 3, NIL, 16);            /* typeOfChargingInfo length */
      ret += 3;

      c = strtol(p += 3, NIL, 16);            /* typeOfChargingInfo contents */
      ret += 3;
      break;
  }
  return(ret);
}
#endif


static int AOC_1TR6(int l, char *p)
{
  auto int EH = 0;
  auto int digit = 0;


  aoc_debug("AOC_INITIAL_1TR6");

  while (l--) {
    digit = strtol(p += 3, NIL, 16) ;

    if ((digit >= '0') && (digit <= '9')) {
      EH = EH * 10;
      EH += (digit - '0'); /* Einheiten sind in ASCII */
    } /* if */
  } /* while */

  return(EH);
} /* AOC_1TR6 */


static void buildnumber(char *num, int type, char *result, int version)
{
  strcpy(result, "");


  switch (type & 0x70) { /* Calling party number Information element, Octet 3 - Table 4-11/Q.931 */
    case 0x00 : if (*num && (*num != '0'))  /* 000 Unknown */
    	      	  strcpy(result, myprefix);
                break;

    case 0x10 : if (version != VERSION_1TR6)
    	          strcpy(result, "00");     /* 001 International */
    	      	break;

    case 0x20 : if (version != VERSION_1TR6)
    	      	  strcpy(result, "0");      /* 010 National */
    	      	break;

    case 0x30 : break;         		    /* 011 Network specific number */

    case 0x40 :	strcpy(result, myprefix);   /* 100 Subscriber number */
    	      	break;

    case 0x60 :	break;	       		    /* 110 Abbreviated number */

    case 0x70 :	break;	      		    /* 111 Reserved for extension */
  } /* switch */

  strcat(result, num);

  print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: num=\"%s\", type=%s, result=\"%s\"\n",
    st + 4, num, i2a(type, 8, 2), result);
} /* buildnumber */


static void decode(int chan, register char *p, int type, int version)
{
  register char     *pd, *px;
  register int       element, l, c, oc;
  auto	   char	     s[BUFSIZ];
  auto 	   struct tm tm;


  while (1) {

    if (!*(p + 2))
      break;

    element = strtol(p += 3, NIL, 16);

    if (element < 128) {

      l = strtol(p += 3, NIL, 16);

      switch (element) {
        case 0x08 : /* Cause */
                    if (version == VERSION_1TR6) {
                      switch (l)  {
                         case 0 : call[chan].cause = 0;
                               	  break;
                         case 1 : call[chan].cause = strtol(p += 3, NIL, 16);
                                  break;
                         case 2 : call[chan].cause = strtol(p += 3, NIL, 16) ;
                               	  c = strtol(p += 3, NIL, 16) ; /* Sometimes it 0xc4 or 0xc5 */
                         	  break;
                        default : p += (l * 3);
                         	  print_msg(PRT_ERR,"Wrong Cause (more than two bytes)");
                         	  break;
                      } /* switch l */

		      info(chan, PRT_SHOWCAUSE, STATE_CAUSE, tr6cause(call[chan].cause));
                    }
                    else { /* E-DSS1 */
                      c = strtol(p += 3, NIL, 16);

                      call[chan].cause = strtol(p += 3, NIL, 16) & 0x7f;

                      if ((call[chan].cause != 0x10) && /* "Normal call clearing" */
                          (call[chan].cause != 0x1a) && /* "non-selected user clearing" */
                          (call[chan].cause != 0x1f) && /* "Normal, unspecified" */
                          (call[chan].cause != 0x51))   /* "Invalid call reference value" <- dies nur Aufgrund eines Bug im Teles-Treiber! */
		        info(chan, PRT_SHOWCAUSE, STATE_CAUSE, CauseValue[call[chan].cause]);
                    } /* else */
                    break;

        case 0x28 : /* Makelweg (wie die Funktion richtig heisst, weiss ich nicht */
                    p += (l * 3);
                    break;

        case 0x2d : /* Parkweg */
                    p += (l * 3);
                    break;

        case 0x2e : /* Parkran */
                    p += (l * 3);
                    /* ggf. neuer Channel kommt gleich mit */
                    break;

        case 0x33 : /* Makelran */
                    p += (l * 3);
                    /* ggf. neuer Channel kommt gleich mit */
                    break;

        case 0x02 : /* Facility AOCE on 1TR6 */
        case 0x1c : /* Facility AOC-D/AOC-E on E-DSS1 */

        	    if (allflags & PRT_DEBUG_DECODE) {
          	      register char *p1 = p;
                      register int   i;
                      auto     char  String[LONG_STRING_SIZE];


                      sprintf(String, " DEBUG> %s: FACILITY:", st + 4);

                      for (i = 0; i < l; i++)
                        sprintf(String+strlen(String), " 0x%02x", (int)strtol(p1 += 3, NIL, 16));

                      print_msg(PRT_DEBUG_DECODE, "%s\n", String);

        	    } /* if */

#ifdef OLD_AOC
	            call[chan].aoce = AOC(l, p);
#else
                    {
                      int n;


                      if ((element == 0x02) && (version == VERSION_1TR6)) {
                        n = AOC_1TR6(l, p);           /* Wieviele Einheiten? */

                        if (type == AOCD_1TR6) {
                          n = -n;  /* Negativ: laufende Verbindung */
                                   /* ansonsten wars ein AOCE */
                          print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: 1TR6 AOCD %i\n", st + 4, n);
                        } /* if */
                      }
                      else
                        n = AOC(l, p, AOC_INITIAL); /* E-DSS1 */

                      /* Dirty-Hack fuer VSt Giessen:
                      	 Diese meldet auch AOC-E als AOC-D */

                      if ((type != FACILITY) && (type != AOCD_1TR6) && (n < 0) ) {
		        aoc_debug("DIRTY-HACK: AOC-D -> AOC-E");
                        n = -n;
                      } /* if */

                      call[chan].aoce = n;

                      sprintf(s, "AOC=%d", n);
		      aoc_debug(s);
                    }
#endif

		    if (call[chan].aoce == AOC_130) {
                      info(chan, PRT_SHOWAOCD, STATE_AOCD, "Free of charge");
                      call[chan].aoce = 0;
		    }
		    else if (call[chan].aoce < 0) {
                      if (currency_factor)
                        sprintf(s, "%s %s (%d s)",
  	                  double2str(-call[chan].aoce * currency_factor, 6, 2, DEB),
                          currency,
                          (int)(cur_time - call[chan].connect));
                      else
                        sprintf(s, "%d.EH = DM %s (%d s)",
                          -call[chan].aoce,
  	                  double2str(-call[chan].aoce * einheit, 6, 2, DEB),
                          (int)(cur_time - call[chan].connect));

                      info(chan, PRT_SHOWAOCD, STATE_AOCD, s);

                      if (*infocmd && aocd && ((-call[chan].aoce > 1) || !connectinfo))
                        tell(infocmd, aocd);
		    } /* else */

                    p += (l * 3);
                    break;

        case 0x29 : /* Date/Time */
             	    tm.tm_year  = strtol(p += 3, NIL, 16);
	     	    tm.tm_mon   = strtol(p += 3, NIL, 16) - 1;
		    tm.tm_mday  = strtol(p += 3, NIL, 16);
		    tm.tm_hour  = strtol(p += 3, NIL, 16);
		    tm.tm_min   = strtol(p += 3, NIL, 16);

		    tm.tm_sec   = 0;
		    tm.tm_wday  = tm.tm_yday = 0;
		    tm.tm_isdst = -1;

                    call[chan].time = mktime(&tm);

                    if (settime) {
  		      auto time_t     tn;
  		      auto struct tms tms;

	      	      time(&tn);

                      if (labs(tn - call[chan].time) > 61) {
       			(void)stime(&call[chan].time);

                        /* Nicht gerade sauber, sollte aber all zu
                           grosse Spruenge verhindern! */

                        if (replay)
                	  cur_time = tt = call[chan].time;
                        else {
      			  time(&cur_time);
      			  tt = times(&tms);
                        } /* else */

              		set_time_str();

                      } /* if */

                      if (settime == 1)
                        settime--;
		    } /* if */

                    sprintf(s, "Time:%s", ctime(&call[chan].time));
                    if ((px = strchr(s, '\n')))
                      *px = 0;

                    info(chan, PRT_SHOWTIME, STATE_TIME, s);
                    break;

        case 0x6c : /* Calling party number */
             	    oc = strtol(p += 3, NIL, 16);

                    if (oc < 128) {
                      c = strtol(p += 3, NIL, 16);
                      l--;
                    } /* if */

                    pd = s;

                    while (--l)
                      *pd++ = strtol(p += 3, NIL, 16);

                    *pd = 0;

                    buildnumber(s, oc, call[chan].num[CALLING], version);

		    strcpy(call[chan].vnum[CALLING],
		      vnum(call[chan].num[CALLING],
		      	   call[chan].vorwahl[CALLING],
		      	   call[chan].rufnummer[CALLING],
		           call[chan].alias[CALLING],
		           call[chan].area[CALLING],
		           &call[chan].confentry[CALLING]));
              	    break;


        case 0x70 : /* Called party number */
             	    oc = strtol(p += 3, NIL, 16);

             	    pd = s;

                    while (--l)
                      *pd++ = strtol(p += 3, NIL, 16);

                    *pd = 0;

                    buildnumber(s, oc, call[chan].num[CALLED], version);

		    strcpy(call[chan].vnum[CALLED],
		      vnum(call[chan].num[CALLED],
		           call[chan].vorwahl[CALLED],
		           call[chan].rufnummer[CALLED],
		           call[chan].alias[CALLED],
		           call[chan].area[CALLED],
		           &call[chan].confentry[CALLED]));

                    if (version != VERSION_1TR6) {
                      /* This message comes before bearer capability */
                      /* So dont show it here, show it at Bearer capability */
                      info(chan, PRT_SHOWNUMBERS, STATE_RING, "");

                      if (sound)
                        ringer(chan, RING_RING);
                      else if (!connectinfo)
                        teller(chan);
                    } /* if */
              	    break;


        case 0x01 : /* Bearer capability 1TR6 */
                    switch (l)  {
                       case 0 : call[chan].bearer = 1 /* Analog */ ;
                              	break;
                       case 1 : call[chan].bearer = strtol(p += 3, NIL, 16);
                              	break;
                       case 2 : call[chan].bearer = strtol(p += 3, NIL, 16) ;
                              	c = strtol(p += 3, NIL, 16) ; /* */
                         	print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: Bearer=%i\n",
                                                         st + 4, call[chan].bearer);
                                break;
                      default : p += (l * 3);
                              	print_msg(PRT_ERR,"Wrong Bearer (more than two bytes)");
                         	break;
                    } /* switch l */

                    info(chan, PRT_SHOWNUMBERS, STATE_RING, "");

                    if (sound)
                      ringer(chan, RING_RING);
                    else if (!connectinfo)
                      teller(chan);
                    break;


        case 0x04 : /* Bearer capability E-DSS1 */
                    switch (l) {
                      case 2 : call[chan].bearer = 0;
                               print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: Bearer=DIGITAL\n",
                               	                  st + 4);
                               break;

                      case 3 : call[chan].bearer = 1;
                               print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: Bearer=ANALOG\n",
                                                  st + 4);
			       break;
                    } /* switch */

        	    p += (l * 3);
             	    break;


        case 0x18 : /* Channel identification */
             	    if (strtol(p + 3, NIL, 16) == 138) {
                      call[chan].self2 = 2;
		      /* Bei mir kommt hier tatsaechlich der B-Kanal! Beim Selbstanruf
   		      	 werden natuerlich beide belegt... jetzt eine 1 fuer Kanal
   			 1 und 2 fuer die 2. 0 heisst unbekannt. chan muss dann spaeter
   			 auf self2-1 gesetzt werden
   			 Beim Parken bleibt der Kanal belegt (bei mir jedenfalls)
   			 und neue Verbindungen kriegen vom Amt den anderen */
                      print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: CHANNEL=Selbstanruf\n", st + 4);

                    }
                    else
                       call[chan].self2 = 1; /* Vielleicht kann man das nutzen */
        	    p += (l * 3);
             	    break;


        case 0x1e : /* Progress indicator */
                    if (allflags & PRT_DEBUG_DECODE) {
                      register int a = strtol(p + 3, NIL, 16);
                      register int b = strtol(p + 6, NIL, 16);
                      register int x = 0;


                      if ((a == 130) && (b == 129))
                        x = 1;
                      else if ((a == 130) && (b == 131))
                        x = 2;
                      else if ((a == 130) && (b == 136))
		        x = 3;
                      else if ((a == 132) && (b == 130))
		        x = 4;
                      else if ((a == 132) && (b == 131))
		      	x = 5;
                      else if ((a == 133) && (b == 130))
		      	x = 6;
                      else if ((a == 138) && (b == 129))
		      	x = 7;
                      else if ((a == 138) && (b == 136))
		      	x = 8;

                      print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: PROGRESS=%d\n", st + 4, x);
                    } /* if */
        	    p += (l * 3);
             	    break;


        case 0x7d : /* High layer compatibility */
                      print_msg(PRT_DEBUG_DECODE, " DEBUG> %s: HIGH LAYER=Phone\n", st + 4);
        	    p += (l * 3);
             	    break;


        default   : if (allflags & PRT_DEBUG_DECODE) {
          	      register char *p1 = p;
        	      register int   i;
                      auto     char  String[LONG_STRING_SIZE];


                      sprintf(String, " DEBUG> %s: ELEMENT=0x%02x :", st + 4, element);

                      for (i = 0; i < l; i++)
                        sprintf(String, " 0x%02x", (int)strtol(p1 += 3, NIL, 16));

                      print_msg(PRT_DEBUG_DECODE, "%s\n", String);
        	    } /* if */

        	    p += (l * 3);
              	    break;
      } /* switch */

    } /* if */
  } /* while */
} /* decode */


int print_msg(int Level, const char *fmt, ...)
{
  auto int     SLevel = PRT_NOTHING;
  auto char    String[LONG_STRING_SIZE];
  auto va_list ap;


  va_start(ap, fmt);
  (void)vsnprintf(String, LONG_STRING_SIZE, fmt, ap);
  va_end(ap);

/*
  if ((Level & PRT_NORMAL) || (Level & PRT_INFO) || (Level & PRT_LOG))
    SLevel = LOG_INFO;
  else if (Level & PRT_ERR)
    SLevel = LOG_ERR;
  else if (Level & PRT_WARN)
    SLevel = LOG_WARNING;
  else if (debug & Level)
    SLevel = LOG_DEBUG;
*/


  SLevel = IS_DEBUG(Level) ? LOG_DEBUG : LOG_INFO;

  if (Level & syslogmessage)
    syslog(SLevel, "%s", String);

  if (Level & stdoutput) {
    fprintf(stdout, "%s\n", String);
    fflush(stdout);
  } /* if */

  if (Level & message)
    if (fcons == NULL)
      fprintf(stderr, "%s", String);
    else
      fprintf(fcons, "%s\r", String);

  if (Level & xinfo)
    print_from_server(String);

  if (Level & PRT_LOG) {
    fprintf(fprot, "%s  %s", stl, String);

    if (synclog)
      fflush(fprot);
  } /* if */

  return(0);
} /* print_msg */


void Exit(int RetCode)
{
  print_msg(PRT_NORMAL, "exit now %d\n", RetCode);

  if (socket_size(sockets) >= 2) {
    close(sockets[ISDNCTRL].descriptor);
    close(sockets[ISDNINFO].descriptor);

    if (xinfo && sockets[IN_PORT].descriptor != -2)
      close(sockets[IN_PORT].descriptor);

  } /* if */

  closelog();
  exit(RetCode);
} /* Exit */


void exit_on_signal(int Sign)
{
  print_msg(PRT_NORMAL, "Got signal %d\n", Sign);

  Exit(7);
} /* exit_on_signal */


/* --------------------------------------------------------------------------
   call reference:


    1 ..  63 DIALIN's    - ist dabei 8. Bit gesetzt, meine Antwort an VSt
                           (cref=1 : VSt->User // cref=129 : User->VSt)

   64 .. 127 DIALOUT's   - ist dabei 8. Bit gesetzt, Antwort der VSt an mich
      	     		   (cref=64 : User->VSt // cref=192 : VSt->User)

   kommt ein SETUP ACKNOWLEDGE mit cref > 128, beginnt ein DIALOUT (!)
   _nicht_ mit der Teles-Karte

   kommt ein CALL PROCEEDING mit cref > 191, beginnt ein DIALOUT
   mit der 2. Teles-Karte

   folgt danach sofort ein SETUP, ist das ein Selbstanruf!


   DIALOUT's erhalten vom Teles-Treiber staendig eine um jeweils 1
   erhoehte call references
   War die letzte cref also < 127, und die naechste = 64, bedeutet dies
   einen Reload des Teles-Treibers!
-------------------------------------------------------------------------- */


static void dotrace()
{
  register int  i;
  auto 	   char s[BUFSIZ];


  print_msg(PRT_NORMAL, ">>>>>>> TRACE (CR=next, q=quit, d=dump, g=go):");
  gets(s);

  if (*s == 'q')
    exit(0);
  else if (*s == 'g')
    trace = 0;
  else if (*s == 'd') {

    print_msg(PRT_NORMAL, "chan=%d\n", chan);

    for (i = 0; i < MAXCHAN; i++) {
      if (call[i].state) {
        print_msg(PRT_NORMAL, "call[%d]:", i);
        print_msg(PRT_NORMAL, "state=%d, cref=%d, ocref=%d, dialin=%d, cause=%d\n",
          call[i].state, call[i].cref, call[i].ocref, call[i].dialin, call[i].cause);
        print_msg(PRT_NORMAL, "\taoce=%d, net=%d, self=%d, self2=%d, dialog=%d\n",
          call[i].aoce, call[i].net, call[i].self, call[i].self2, call[i].dialog);
        print_msg(PRT_NORMAL, "\trelease=%d, bearer=%d, pid=%d\n",
          call[i].release, call[i].bearer, sockets[call[i].sock].pid);
        print_msg(PRT_NORMAL, "\tnum[0]=\"%s\", num[1]=\"%s\"\n",
          call[i].num[0], call[i].num[1]);
        print_msg(PRT_NORMAL, "\tvnum[0]=\"%s\", vnum[1]=\"%s\"\n",
          call[i].vnum[0], call[i].vnum[1]);
        print_msg(PRT_NORMAL, "\tconfentry[0]=%d,  confentry[1]=%d\n",
          call[i].confentry[0], call[i].confentry[1]);
        print_msg(PRT_NORMAL, "\ttime=%d, connect=%d, disconnect=%d, duration=%d\n",
          (int)call[i].time, (int)call[i].connect, (int)call[i].disconnect, (int)call[i].duration);
      } /* if */
    } /* for */

    dotrace();

  } /* if */
} /* dotrace */


static void processinfo(char *s)
{
  register int	       j, chan;
  auto	   char	       sx[BUFSIZ];
  static   long        i[16], o[16];
  static   int         u[16], f[16], ch[16], dr[16];
  static   char        id[20][16], n[20][16];
  auto	   time_t      DiffTime = (time_t)0;


  if (verbose)
    print_msg(PRT_LOG, "%s\n", s);


  if (!memcmp(s, "idmap:", 6)) {
    memset(id, 0, sizeof(id));

    sscanf(s + 7, "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
      id[ 0], id[ 1], id[ 2], id[ 3],
      id[ 4], id[ 5], id[ 6], id[ 7],
      id[ 8], id[ 8], id[10], id[11],
      id[12], id[13], id[14], id[15]);
  }
  else if (!memcmp(s, "chmap:", 6)) {
    memset(ch, 0, sizeof(ch));

    sscanf(s + 7, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
      &ch[ 0], &ch[ 1], &ch[ 2], &ch[ 3],
      &ch[ 4], &ch[ 5], &ch[ 6], &ch[ 7],
      &ch[ 8], &ch[ 8], &ch[10], &ch[11],
      &ch[12], &ch[13], &ch[14], &ch[15]);
  }
  else if (!memcmp(s, "drmap:", 6)) {
    memset(dr, 0, sizeof(dr));

    sscanf(s + 7, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
      &dr[ 0], &dr[ 1], &dr[ 2], &dr[ 3],
      &dr[ 4], &dr[ 5], &dr[ 6], &dr[ 7],
      &dr[ 8], &dr[ 8], &dr[10], &dr[11],
      &dr[12], &dr[13], &dr[14], &dr[15]);
  }
  else if (!memcmp(s, "usage:", 6)) {
    memset(u,  0, sizeof(u));

    sscanf(s + 7, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
      &u[ 0], &u[ 1], &u[ 2], &u[ 3],
      &u[ 4], &u[ 5], &u[ 6], &u[ 7],
      &u[ 8], &u[ 9], &u[10], &u[11],
      &u[12], &u[13], &u[14], &u[15]);
  }
  else if (!memcmp(s, "flags:", 6)) {
    memset(f,  0, sizeof(f));

    sscanf(s + 7, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
      &f[ 0], &f[ 1], &f[ 2], &f[ 3],
      &f[ 4], &f[ 5], &f[ 6], &f[ 7],
      &f[ 8], &f[ 9], &f[10], &f[11],
      &f[12], &f[13], &f[14], &f[15]);
  }
  else if (!memcmp(s, "phone:", 6)) {
    memset(n,  0, sizeof(n));

    sscanf(s + 7, "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s",
      n[ 0], n[ 1], n[ 2], n[ 3],
      n[ 4], n[ 5], n[ 6], n[ 7],
      n[ 8], n[ 8], n[10], n[11],
      n[12], n[13], n[14], n[15]);
  }
  else if (!memcmp(s, "ibytes:", 7)) {
    memset(i,  0, sizeof(i));

    sscanf(s + 8, "%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",
      &i[ 0], &i[ 1], &i[ 2], &i[ 3],
      &i[ 4], &i[ 5], &i[ 6], &i[ 7],
      &i[ 8], &i[ 9], &i[10], &i[11],
      &i[12], &i[13], &i[14], &i[15]);
  }
  else if (!memcmp(s, "obytes:", 7)) {
    memset(o,  0, sizeof(o));

    sscanf(s + 8, "%ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld %ld",
      &o[ 0], &o[ 1], &o[ 2], &o[ 3],
      &o[ 4], &o[ 5], &o[ 6], &o[ 7],
      &o[ 8], &o[ 9], &o[10], &o[11],
      &o[12], &o[13], &o[14], &o[15]);


    for (j = 0; j < 2; j++) {
      for (chan = 0; chan < 2; chan++)
        if (memcmp(n[j], "???", 3) && !strcmp(n[j], call[chan].num[OTHER])) {
      	  call[chan].ibytes = i[j];
      	  call[chan].obytes = o[j];

	  strcpy(call[chan].id, id[j]);

      	  if (!(u[j] & ISDN_USAGE_MASK)) /* no connection */
            strcpy(call[chan].usage, (u[j] & ISDN_USAGE_EXCLUSIVE) ? "Exclusive" : "Offline");
      	  else {
      	    switch (u[j] & ISDN_USAGE_MASK) {
	      case ISDN_USAGE_RAW   : sprintf(call[chan].usage, "%s %s", (u[j] & ISDN_USAGE_OUTGOING) ? "Outgoing" : "Incoming", "Raw");
	         		      break;

	      case ISDN_USAGE_MODEM : sprintf(call[chan].usage, "%s %s", (u[j] & ISDN_USAGE_OUTGOING) ? "Outgoing" : "Incoming", "Modem");
	       			      break;

	      case ISDN_USAGE_NET   : sprintf(call[chan].usage, "%s %s", (u[j] & ISDN_USAGE_OUTGOING) ? "Outgoing" : "Incoming", "Net");
	    	 		      break;

	      case ISDN_USAGE_VOICE : sprintf(call[chan].usage, "%s %s", (u[j] & ISDN_USAGE_OUTGOING) ? "Outgoing" : "Incoming", "Voice");
	       			      break;

	      case ISDN_USAGE_FAX   : sprintf(call[chan].usage, "%s %s", (u[j] & ISDN_USAGE_OUTGOING) ? "Outgoing" : "Incoming", "Fax");
	       			      break;
      	    } /* switch */
          } /* else */

          DiffTime = cur_time - call[chan].connect;

          if (DiffTime) {
            call[chan].ibps = (double)(i[j] / (double)(DiffTime));
            call[chan].obps = (double)(o[j] / (double)(DiffTime));
          }
          else
            call[chan].ibps = call[chan].obps = 0.0;

          if (call[chan].ibytes + call[chan].obytes) {

#if OUT_WORKS
      	    sprintf(sx, "IN=%ld Byte  OUT=%ld Byte", call[chan].ibytes, call[chan].obytes);
#else
      	    sprintf(sx, "%s kB / %s bps",
      	      double2str((double)call[chan].ibytes / 1024.0, 10, 2, 0),
      	      double2str((double)call[chan].ibps, 8, 2, 0));
#endif
            info(chan, PRT_SHOWBYTE, STATE_BYTE, sx);
          } /* if */
        } /* if */
    } /* for */
  } /* else */
} /* processinfo */


static void processctrl(char *s)
{
  register char       *ps = s;
  register int         i;
  register int         wegchan; /* fuer gemakelte */
  auto 	   int 	       ref, dialin, type, cref, version;
  static   int	       tei = 0, net = 1;
  auto 	   char	       sx[BUFSIZ];


  if (verbose)
    print_msg(PRT_LOG, "%s\n", s);

  /* Tei wird gelesen und bleibt bis zum Ende des naechsten hex: stehen.
     Der naechste hex: -Durchlauf hat also die korrekte tei.*/

  if (!memcmp(ps, "Q.931 frame network->user tei ", 30)) {
    tei = strtol(ps += 30, NIL, 10);
    net = 1;
  }
  else if (!memcmp(ps, "Q.931 frame user->network tei ", 30)) {
    tei = strtol(ps += 30, NIL, 10);
    net = 0;
  }
  else if (!memcmp(ps, "Q.931 frame network->user with tei ", 35)) {
    tei = strtol(ps += 35, NIL, 10);
    net = 1;
  }
  else if (!memcmp(ps, "Q.931 frame network->user", 25))
    net = 1;
  else if (!memcmp(ps, "hex: ", 5)) {
    i = strtol(ps += 5, NIL, 16);

    switch (i) {
      case 0x40 :
      case 0x41 : version = VERSION_1TR6;    break;

      case 0x08 : version = VERSION_EDSS1;   break;

      default   : version = VERSION_UNKNOWN; break;
    } /* switch */

#ifdef SL
    if (version == VERSION_1TR6) {
      print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: OOPS! 1TR6 Frame? Ignored!\n", st + 4);
      goto endhex;
    } /* if */
#endif

    cref = strtol(ps += 6, NIL, 16);
    type = strtol(ps += 3, NIL, 16);


    cref = (net) ? cref : cref ^ 0x80; /* cref immer aus Sicht des Amts */
    ref = cref ^ 0x80;

    dialin = !tei; /* Keine tei -> dialin (Broadcast), alle anderen haben schon eine Tei! */

    if (allflags & PRT_DEBUG_DIAG)
      diag(cref, tei, dialin, net, type, version);

    /* leider laesst sich kein switch nehmen, da decode
       innerhalb von SETUP/A_ACK aufgerufen werden muss, sonst
       aber erst nach feststellen von chan
       Daher GOTO (urgs...) an das Ende vom if hex:.. */

    if (type == SETUP) { /* neuen Kanal, ev. dummy, wenn keiner da ist */
      chan = 5; /* den nehmen wir _nur_ dafuer! */
      memset((char *)&call[chan], 0, sizeof(CALL));
      strcpy(call[chan].vnum[0], "?");
      strcpy(call[chan].vnum[1], "?");
      call[chan].aoce = -1;
      call[chan].dialin = !tei;
      call[chan].tei = tei;
      decode(chan, ps, type, version);

      if (call[chan].self2) { /* Aha, Kanal war dabei, dann nehmen wir den gleich */
        chan = call[chan].self2 - 1;

        print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: Chan auf %d gesetzt\n", st + 4, chan);

        /* nicht --self2, self2 muss unveraendert bleiben! */
        memcpy((char *)&call[chan], (char *)&call[5], sizeof(CALL));
        change_channel(5, chan);
        memset((char *)&call[5], 0, sizeof(CALL));
        strcpy(call[5].vnum[0], "?");
        strcpy(call[5].vnum[1], "?");
      } /* if */

      call[chan].cref = (dialin) ? cref : (cref | 0x80); /* immer die cref, die _vom_ Amt kommt/kommen sollte */
      call[chan].dialin = dialin;
      call[chan].tei = tei;
      call[chan].connect = cur_time;
      call[chan].duration = tt;
      call[chan].state = type;

      print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: START CHAN#%d tei %d cref %d %d %s %s->\n",
        st + 4, chan, tei, cref, call[chan].cref,
        call[chan].dialin ? " IN" : "OUT",
        call[chan].net ? "NET" : "USR");

      goto endhex;
    } /* if SETUP */

    if ((type == SETUP_ACKNOWLEDGE) || (type == CALL_PROCEEDING)) {
      /* Kann sein, dass ein SETUP vorher kam, suchen wir mal, denkbar:
       	   a) SETUP in 5 (eig. rausruf): decode auf 5, dann copy nach self2
       	   b) nichts (rausruf fremd): decode auf 5, copy nach self2 */

      chan = 5;

      if ((call[5].cref != cref) || (call[5].tei != tei)) {
        /* bei C_PROC/S_ACK ist cref _immer_ > 128 */
        /* keiner da, also leeren */
        memset((char *)&call[chan], 0, sizeof(CALL));
        strcpy(call[chan].vnum[0], "?");
        strcpy(call[chan].vnum[1], "?");
        call[chan].aoce = -1;
        call[chan].dialin = !tei;
        call[chan].tei = tei;
        call[chan].cref = cref;
      } /* if */

      decode(chan, ps, type, version);

      if (call[chan].self2) { /* jetzt muesste einer da sein */

        chan = call[chan].self2 - 1;

        /* nicht --self2, self2 muss unveraendert bleiben! */
        memcpy((char *)&call[chan], (char *)&call[5], sizeof(CALL));
        change_channel(5, chan);
        memset((char *)&call[5], 0, sizeof(CALL));
        strcpy(call[5].vnum[0], "?");
        strcpy(call[5].vnum[1], "?");
      }
      else
        print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: OOPS, C_PROC/S_ACK ohne channel? tei %d\n",
          st + 4, tei);

      call[chan].connect = cur_time;
      call[chan].duration = tt;
      call[chan].state = type;

      print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: START CHAN#%d tei %d %s %s->\n",
        st + 4, chan, tei,
        call[chan].dialin ? " IN" : "OUT",
        call[chan].net ? "NET" : "USR");
      goto endhex;
    } /* if C_PROC || S_ACK */

    if (type == AOCD_1TR6) {
      decode(chan, ps, type, version);
      goto endhex;
    } /* if AOCD_1TR6 */

    /* Beim Makeln kommt Geb. Info nur mit Cref und Tei, die
       cref muessen wir dann in chan 2/3 suchen */

    /* Bei geparkten Gespr. kommen die waehrend des Parkens
       aufgelaufenen Gebuehren beim Wiederholen. */

    if ((cref != call[0].cref) && (cref != call[1].cref) &&
        (cref != call[2].cref) && (cref != call[3].cref))

      /* Mit falscher cref kommt hier keiner rein, koennte
      	 ein RELEASE auf bereits freiem Kanal sein */
      goto endhex;

    /* So, wenn wir hier ankommen, haben wir auf jeden Fall einen
       Kanal (0, 1, 2 oder 3) und eine cref. Die tei folgt evtl. erst beim
       Connect (Reinruf). Suchen wir den Kanal: */

    /* crefs absuchen. Gibt's die mehrmals, tei absuchen, dann haben wir
       ihn.
       Es kann aber sein, dass cref stimmt, aber noch keine tei da war
       (Reinruf). Dann ist aber die cref eindeutig (hoffentlich)!
       finden wir einen Kanal mit passender cref, der keine
       tei hat, haben wir ihn. Hat er eine, und sie stimmt,
       ebenso. Sonst weitersuchen. Geparkte Kanaele ignorieren
       bis zum RESUME, oder sie werden bei neuem SETUP_ACK. ueber-
       schrieben, wenn wir wen im Parken verhungen lassen haben */

    chan = -1;

    for (i = 0; ((i < 4) &&
      ((call[i].cref != cref) ||
        ((call[i].state == SUSPEND) && (type != RESUME_ACKNOWLEDGE)) ||
        ((call[i].tei) && (call[i].tei != tei)))); i++);
      chan = i;

    print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: Kanal %d\n", st + 4, chan);

    /* auch wenn hier schon eine tei bei ist, erst beim connect hat
       ein reingerufener Kanal eine gueltige tei*/

    decode(chan, ps, type, version);

    switch (type) {

      case CONNECT             :
      case CONNECT_ACKNOWLEDGE :

	/* Bei Rufen an die Teles kommt CONNECT und CONN.ACKN., eins reicht uns */
	if (call[chan].state == CONNECT)
	  goto doppelt;

	call[chan].state = CONNECT;
	call[chan].tei = tei;
	call[chan].dialog++; /* es hat connect gegeben */
        call[chan].connect = cur_time;
        call[chan].duration = tt;

        info(chan, PRT_SHOWCONNECT, STATE_CONNECT, "CONNECTED");

        if (sound)
          ringer(chan, RING_CONNECT);
        else if (connectinfo)
          teller(chan);

doppelt:break;

      case SUSPEND_ACKNOWLEDGE :
        call[chan].state = SUSPEND;
        info(chan, PRT_SHOWHANGUP, STATE_HANGUP, "PARK");
        break;

      case RESUME_ACKNOWLEDGE :
        call[chan].state = CONNECT;
        info(chan, PRT_SHOWCONNECT, STATE_CONNECT, "RESUME");
        break;

      case MAKEL_ACKNOWLEDGE :
        wegchan = (call[2].state) ? 3 : 2;
        memcpy((char *)&call[wegchan], (char *)&call[chan], sizeof(CALL));
        change_channel(chan, wegchan);
        memset((char *)&call[chan], 0, sizeof(CALL));
        strcpy(call[chan].vnum[0], "?");
        strcpy(call[chan].vnum[1], "?");
        call[wegchan].state = MAKEL_ACKNOWLEDGE;
        info(wegchan, PRT_SHOWHANGUP, STATE_HANGUP, "MAKEL");
        break;

      case MAKEL_RESUME_ACK :
        if (call[chan].self2) { /* muesste einer da sein */
          memcpy((char *)&call[call[chan].self2 - 1], (char *)&call[chan], sizeof(CALL));
          call[call[chan].self2 - 1].self2 = chan; /* den alten merken */
          change_channel(chan, call[chan].self2 - 1);
          chan = call[chan].self2 - 1; /* chan setzen */
          memset((char *)&call[call[chan].self2], 0, sizeof(CALL));
          strcpy(call[call[chan].self2].vnum[0], "?");
          strcpy(call[call[chan].self2].vnum[1], "?");
          call[chan].self2 = chan + 1; /* in Ordnung bringen */
          call[chan].state = CONNECT;
        } /* if */

        info(chan, PRT_SHOWCONNECT, STATE_CONNECT, "MAKELRESUME");
        break;


      case DISCONNECT          :

	if (!call[chan].state) /* Keine Infos -> Weg damit */
	  break;

	call[chan].disconnect = cur_time;

	if (replay)
          call[chan].duration = (tt - call[chan].duration) * 100;
	else
          call[chan].duration = tt - call[chan].duration;

        call[chan].state = DISCONNECT;

        break;


      case RELEASE             :
      case RELEASE_COMPLETE    :

        if (!net) /* wir nehmen nur RELEASE vom Amt */
          break;

        if (!call[chan].state) /* Keine Infos -> Weg damit */
          break;

        /* Statt der Konstrukte haben wir uns gemerkt, ob's ein CONNECT gab.
           Wenn nicht, hat's auch nichts gekostet. */
        /* Falls der RELEASE aber ein Rufablehnen war und der
           CONNECT noch folgt, wird dafuer jetzt chan auf
           4 gepackt, um die schoenen Daten in 0/1/ev.4 nicht
           zu zerstoeren. Wir erkennen das an fehlender tei. */

        if (!call[chan].tei) {
          memcpy((char *)&call[4], (char *)&call[chan], sizeof(CALL));
          change_channel(chan, 4);
          chan = 4;
          call[chan].tei = tei;
        } /* if */

	if (!call[chan].disconnect) {
  	  call[chan].disconnect = cur_time;

	  if (replay)
            call[chan].duration = (tt - call[chan].duration) * 100;
	  else
            call[chan].duration = tt - call[chan].duration;
        } /* if */

	if (!call[chan].dialog) {
          call[chan].duration = 0;
  	  call[chan].disconnect = call[chan].connect;

          print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: CHAN#%d genullt (dialin=%d, state=%d, tei=%d, cref=%d)\n",
            st + 4, chan, call[chan].dialin, call[chan].state, call[chan].tei,call[chan].cref);

          print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: OOPS! DURATION=0\n", st + 4);
        } /* if kein connect */

       	if (allflags & PRT_DEBUG_BUGS) {
          strcpy(sx, ctime(&call[chan].connect));
      	  sx[19] = 0;

          print_msg(PRT_DEBUG_BUGS, " DEBUG> %s: LOG CHAN#%d(%s : DIAL%s : %s -> %s : %d s (%d s) : %d EH):%s\n\n",
            st + 4, chan,
      	    sx + 4,
      	    call[chan].dialin ? "IN" : "OUT",
      	    call[chan].num[CALLING],
      	    call[chan].num[CALLED],
      	    (int)(call[chan].disconnect - call[chan].connect),
            (int)call[chan].duration,
      	    call[chan].aoce,
      	    CauseValue[call[chan].cause]);
       	} /* if */

        logger(chan);

	if (call[chan].dialog || any) { /* AK:14-Mar-96 ::
	   		      	      	     Unterdrueckung der HANGUP-Meldungen
                                             falls andere Geraete am Bus den Ruf
                                             abgelehnt haben */
          if (call[chan].dialin)
            sprintf(sx, "HANGUP (%d s)",
              (int)(call[chan].disconnect - call[chan].connect));
          else {
            if (call[chan].aoce > 0) {
              if (currency_factor)
                sprintf(sx, "HANGUP (%s %s = %d s)",
                  double2str(call[chan].aoce * currency_factor, 6, 2, DEB),
                  currency,
                  (int)(call[chan].disconnect - call[chan].connect));
              else
                sprintf(sx, "HANGUP (%d EH = DM %s = %d s)",
                  call[chan].aoce,
                  double2str(call[chan].aoce * einheit, 6, 2, DEB),
                  (int)(call[chan].disconnect - call[chan].connect));
            }
            else {
              if (version == VERSION_1TR6)
                sprintf(sx, "HANGUP (%d s) %s",
                        (int)(call[chan].disconnect - call[chan].connect),
                         tr6cause(call[chan].cause));
              else
                sprintf(sx, "HANGUP (%d s) %s",
                        (int)(call[chan].disconnect - call[chan].connect),
                         CauseValue[call[chan].cause]);
            } /* else */
          } /* else */

          info(chan, PRT_SHOWHANGUP, STATE_HANGUP, sx);

          if (sound)
            ringer(chan, RING_KILL);
          else if (*infocmd && hangup)
            tell(infocmd, hangup);
        } /* if */

        call[chan].state = 0;
        call[chan].dialog = 0;
        call[chan].cref = 0;
        call[chan].tei = 0;

     	break;

    } /* switch */

endhex:
    tei = 0; /* Wenn nach einer tei-Zeile keine hex:-Zeile kommt, tei ungueltig machen! */
  } /* if */
} /* processctrl */


static void now()
{
  auto struct tms tms;


  time(&cur_time);
  tt = times(&tms);
  set_time_str();
} /* now */


static void alarm_handler()
{
  signal(SIGALRM, alarm_handler);
  alarm(wakeup);
} /* alarm_handler */


static int morectrl()
{
  register char      *p, *p1, *p2, *p3;
  static   char       s[BIGBUFSIZ];
  static   char      *ps = s;
  auto	   int        n = 0;
  auto 	   struct tm *tm;


  signal(SIGALRM, alarm_handler);
  alarm(wakeup);

  if ((n = read(sockets[ISDNCTRL].descriptor, ps, BUFSIZ)) > 0) {

    alarm(0);

    now();

    ps += n;

    *ps = 0;

    p1 = s;

    while ((p = p2 = strchr(p1, '\n'))) {
      *p = 0;

      while (*--p == ' ')
        *p = 0;

      if (replay) {

        if (replaydev)
          p3 = p1;
        else {
    	  cur_time = tt = atom(s + 4);

    	  set_time_str();

    	  tm = localtime(&cur_time);
    	  einheit = (tm->tm_year > 95) ? 0.12 : 0.23;

    	  p3 = p1 + 26;
        } /* if */

        if (!memcmp(p3, "idmap:", 6) ||
            !memcmp(p3, "chmap:", 6) ||
            !memcmp(p3, "drmap:", 6) ||
            !memcmp(p3, "usage:", 6) ||
            !memcmp(p3, "flags:", 6) ||
            !memcmp(p3, "phone:", 6) ||
            !memcmp(p3, "ibytes:", 7) ||
            !memcmp(p3, "obytes:", 7))
      	  processinfo(p3);
        else
          processctrl(p3);
      }
      else
        processctrl(p1);

      p1 = p2 + 1;
    } /* while */

    if (p1 < ps) {
      n = ps - p1;
      memmove(s, p1, n);
      ps = s + n;
    }
    else
      ps = s;

    return(1);
  }
  else
    return(0);
} /* morectrl */


static void moreinfo()
{
  register char *p, *p1, *p2;
  static   char  s[BIGBUFSIZ];
  static   char *ps = s;
  auto	   int   n;


  if ((n = read(sockets[ISDNINFO].descriptor, ps, BUFSIZ)) > 0) {
    now();
    ps += n;

    *ps = 0;

    p1 = s;

    while ((p = p2 = strchr(p1, '\n'))) {
      *p = 0;

      while (*--p == ' ')
        *p = 0;

      processinfo(p1);

      p1 = p2 + 1;
    } /* while */

    if (p1 < ps) {
      n = ps - p1;
      memmove(s, p1, n);
      ps = s + n;
    }
    else
      ps = s;
  } /* if */
} /* moreinfo */


static void loop()
{
  auto fd_set readmask;
  auto int    Cnt;
  auto int    len;
  auto int    queuenumber;
  auto int    NewSocket;
  auto int    NewClient = 0;
  auto struct sockaddr incoming;


  if (xinfo)
    if ((NewSocket = listening(port)) >= 0) {
      if (add_socket(&sockets,NewSocket))
	Exit(11);
    }
    else
      Exit(17);

  while (1) {
    if (replay) {

      if (trace)
        dotrace();

      if (!morectrl())
        break;
    }
    else {
      FD_ZERO(&readmask);

      queuenumber = socket_size(sockets);

      if (NewClient) {
        /* Damit sich der neue Client anmelden kann, ohne
           das was anderes dazwischen funkt ... */
        FD_SET(sockets[NewClient].descriptor, &readmask);
      	NewClient = 0;
      }
      else
        for (Cnt = 0; Cnt < queuenumber; Cnt++)
          FD_SET(sockets[Cnt].descriptor, &readmask);

      if ((Cnt = select(FD_SETSIZE, &readmask, NULL, NULL, NULL)) <= 0) {
        print_msg(PRT_DEBUG_CS,"Error select: %s\n", strerror(errno));
        Exit(12);
      } /* if */

      now();

      queuenumber = socket_size(sockets);

      for (Cnt = FIRST_DESCR; Cnt < queuenumber; Cnt++)
        if (FD_ISSET(sockets[Cnt].descriptor, &readmask))
          if (sockets[Cnt].fp == NULL)
            eval_message(Cnt);
          else
            Print_Cmd_Output(Cnt);

      if (xinfo && FD_ISSET(sockets[IN_PORT].descriptor, &readmask)) {
        len = sizeof(incoming);

        if ((NewSocket = accept(sockets[IN_PORT].descriptor,&incoming,&len)) == -1)
          print_msg(PRT_DEBUG_CS, "Error accept: %s\n", strerror(errno));
        else {
          if (add_socket(&sockets, NewSocket))
            Exit(13);

      	  queuenumber = socket_size(sockets);

          sockets[queuenumber-1].f_hostname = Get_Hostname(&incoming);
          sockets[queuenumber-1].waitstatus = WF_ACC;

          NewClient = queuenumber - 1;
        } /* else */
      }
      else if (FD_ISSET(sockets[ISDNINFO].descriptor, &readmask))
        moreinfo();
      else if (FD_ISSET(sockets[ISDNCTRL].descriptor, &readmask))
        (void)morectrl();
		}
  } /* while */
} /* loop */


int main(int argc, char *argv[], char *envp[])
{
  register char *p;
  register int	 i, c, res = 0;
  auto 	   char* ptty = NULL;
  auto 	   char  fn[BUFSIZ], logname[BUFSIZ];
  auto 	   FILE *fp;
  auto     int   defaultmsg = message = PRT_NORMAL | PRT_WARN | PRT_ERR | PRT_INFO;
  auto     int   newmessage = 0;


  *infocmd = 0;
  sockets = NULL;
  allflags = 0;
  dbm = (DBM *)NULL;
  einheit = 0.12;
  known = (KNOWN **)NULL;

  myname = argv[0];
  myshortname = basename(myname);

  while ((c = getopt(argc, argv, options)) != EOF)
    switch (c) {
      case 'V' : printf("%s Version %s, Copyright (C) 1995, 1996 Andreas Kool\n", myshortname, VERSION);
      	       	 printf("%s comes with ABSOLUTELY NO WARRANTY; for details see COPYING.\n", myshortname);
                 printf("This is free software, and you are welcome to redistribute it\n");
                 printf("under certain conditions; see COPYING for details.\n");
      	       	 return(0);
  		 break;

      case 'v' : verbose++;
      	       	 break;

      case 's' : synclog++;
      	       	 break;

      case 'i' : strcpy(infocmd, optarg);
      	       	 break;

      case 'c' : connectinfo++;
      	       	 break;

      case 'p' : port = strtol(optarg, NIL, 0);
      	       	 break;

      case 'm' : newmessage = strtol(optarg, NIL, 0);

      	       	 if (!newmessage) {
                   newmessage = defaultmsg;
                   printf("%s: WARNING: \"-m\" Option now requires numeric Argument\n", myshortname);
                 } /* if */
      	       	 break;

      case 'l' : syslogmessage = strtol(optarg, NIL, 0);

               	 if (!syslogmessage) {
                   syslogmessage = defaultmsg;
                   printf("%s: WARNING: \"-l\" Option requires numeric Argument\n", myshortname);
                 } /* if */
                 break;

      case 'x' : xinfo = strtol(optarg, NIL, 0);

               	 if (!xinfo)
                   xinfo = defaultmsg;
      	       	 break;

      case 'r' : replay++;
      	       	 break;

      case 'R' : replay++;
      	       	 replaydev++;
                 break;

      case 't' : settime = strtol(optarg, NIL, 0); /* 1=once, 2=ever */
      	       	 break;

      case 'C' : ptty = strdup(optarg);
      	       	 break;

      case 'S' : sound++;
      	       	 break;

      case 'w' : wakeup = strtol(optarg, NIL, 0);
      	       	 break;

      case 'D' : daemon++;
      	       	 break;

      case 'T' : trace++;
      	       	 break;

      case 'a' : any = 0;
      	       	 break;

      case 'P' : stdoutput = PRT_LOG;
      	       	 break;

      case 'e' : showtei = 0;
      	       	 break;

      case '?' : printf(usage, myshortname, myshortname, options);
	         return(1);
    } /* switch */

    if (newmessage)
      message = newmessage;

    if (trace && daemon) {
      printf("%s","Can not trace and daemon together!\n");
      Exit(20);
    } /* if */

    if (stdoutput && daemon) {
      printf("%s","Can not write to stdout as daemon!\n");
      Exit(21);
    } /* if */

    if (daemon) {
      if (syslogmessage == -1)
        syslogmessage = defaultmsg;

      switch (fork()) {
        case -1 : print_msg(PRT_ERR,"%s","Can not start fork()!\n");
                  Exit(18);
                  break;
        case 0  : break;

        default : _exit(0);
      }

      /* message nicht explixit gesetzt wurde, dann gibt es beim daemon auch
         kein Output auf der Console/ttyx                                   */

      if (!newmessage && ptty == NULL)
        message = 0;
    } /* if */

  allflags = syslogmessage | message | xinfo | stdoutput;

  if (optind < argc) {

    if (add_socket(&sockets, -1) ||  /* reserviert fuer isdnctrl */
        add_socket(&sockets, -1)   ) /* reserviert fuer isdninfo */
      Exit(-19);

    strcpy((char *)logname, LOGFILE);

    if (replay)
      strcat((char *)logname, ".rep");

    openlog(myshortname, LOG_NDELAY, LOG_DAEMON);

    print_msg(PRT_NORMAL, "%s Version %s loading\n", myshortname, VERSION);

    signal(SIGPIPE, SIG_IGN);
    signal(SIGHUP,  hup_handler);
    signal(SIGINT,  exit_on_signal);
    signal(SIGTERM, exit_on_signal);
    signal(SIGALRM, exit_on_signal);
    signal(SIGQUIT, exit_on_signal);
    signal(SIGILL,  exit_on_signal);

    if (allflags == PRT_DEBUG_GENERAL)
      signal(SIGSEGV, exit_on_signal);

    sockets[ISDNCTRL].descriptor = !strcmp(argv[optind], "-") ? fileno(stdin) : open(argv[optind], O_RDONLY | O_NONBLOCK);

    if (sockets[ISDNCTRL].descriptor >= 0) {

      if (ptty != NULL) {
        sprintf(fn, "/dev/tty%s", ptty);
        fcons = fopen(fn, "a");
      } /* else */

      if (ptty == NULL || fcons != (FILE *)NULL) {
        if ((flog = fopen(logname, "a")) != (FILE *)NULL) {

          if (verbose) {
            if ((p = strrchr(argv[optind], '/')))
              p++;
            else
              p = argv[optind];

            sprintf(fn, "%s/%s", TMPDIR, p);
          } /* if */

          if (!verbose || ((fprot = fopen(fn, "a")) != (FILE *)NULL)) {

            memset(call, 0, sizeof(call));

            for (i = 0; i < MAXCHAN; i++) {
              strcpy(call[i].vnum[0], "?");
              strcpy(call[i].vnum[1], "?");
            } /* for */

            readconfig(myshortname);

            if (!replay)
              if ((fp = fopen(PIDFILE, "w")) != (FILE *)NULL) {
                fprintf(fp, "%d\n", (int)getpid());
                fclose(fp);
                (void)chmod(PIDFILE, 0644);
              } /* if */

            if (replay || ((sockets[ISDNINFO].descriptor = open(INFO, O_RDONLY | O_NONBLOCK)) >= 0)) {

              loop();

              if (sockets[ISDNINFO].descriptor >= 0)
                close(sockets[ISDNINFO].descriptor);
            }
            else {
              print_msg(PRT_ERR, msg1, myshortname, INFO, strerror(errno));
              res = 7;
            } /* else */

            if (verbose)
              fclose(fprot);
          }
          else {
            print_msg(PRT_ERR, msg1, myshortname, fn, strerror(errno));
            res = 5;
          } /* else */

          fclose(flog);
        }
    	else {
      	  print_msg(PRT_ERR, msg1, myshortname, logname, strerror(errno));
      	  res = 4;
    	} /* else */

        if (ptty != NULL)
          fclose(fcons);
      }
      else {
        print_msg(PRT_ERR, msg1, myshortname, fn, strerror(errno));
        res = 3;
      } /* else */

      close(sockets[ISDNCTRL].descriptor);
    }
    else {
      print_msg(PRT_ERR, msg1, myshortname, argv[optind], strerror(errno));
      res = 2;
    } /* else */

    print_msg(PRT_NORMAL, "%s Version %s exiting\n", myshortname, VERSION);
    closelog();

  }
  else {
    print_msg(PRT_ERR, usage, myshortname, myshortname, options);
    res = 1;
  } /* else */

  return(res);
} /* main */
